// ArrayOfLedArrays - see https://github.com/FastLED/FastLED/wiki/Multiple-Controller-Examples for more info on
// using multiple controllers.  In this example, we're going to set up three NEOPIXEL strips on three
// different pins, each strip getting its own CRGB array to be played with, only this time they're going
// to be all parts of an array of arrays.

#include "FastLED.h"
#include <TimerOne.h>

//RGB Buttons

#define Button1_Red 50
#define Button1_Blue 51
#define Button1_Feedback 21
bool Button1_currentbuttonState=LOW;             // the current reading from the input pin
bool Button1_RedState= LOW;
bool Button1_BlueState= HIGH;

#define Button2_Red 36
#define Button2_Blue 37
#define Button2_Feedback 19
bool Button2_currentbuttonState=LOW;             // the current reading from the input pin
bool Button2_RedState= LOW;
bool Button2_BlueState= HIGH;

#define Button3_Red 42
#define Button3_Blue 43
#define Button3_Feedback 20
bool Button3_currentbuttonState=LOW;             // the current reading from the input pin
bool Button3_RedState= LOW;
bool Button3_BlueState= HIGH;

#define Button4_Red 24
#define Button4_Blue 25
#define Button4_Feedback 18
bool Button4_currentbuttonState=LOW;             // the current reading from the input pin
bool Button4_RedState= LOW;
bool Button4_BlueState= HIGH;

//bool Button1_lastButtonState = LOW;   // the previous reading from the input pin

unsigned long lastDebounceTime = 0;  // the last time the output pin was toggled
unsigned long debounceDelay = 50;    // the debounce time; increase if the output flickers

//RGB LED STRIPS
#define RED 0xFF0000 
#define BLUE 0x0000FF
#define NUM_STRIPS 8
#define NUM_LEDS_PER_STRIP 42
#define NUM_LEDS_STRIP0 42
#define NUM_LEDS_STRIP1 17
#define NUM_LEDS_STRIP2 31
#define NUM_LEDS_STRIP3 41
#define NUM_LEDS_STRIP4 25
#define NUM_LEDS_STRIP5 19
#define NUM_LEDS_STRIP6 29
#define NUM_LEDS_STRIP7 28
CRGB leds[NUM_STRIPS][NUM_LEDS_PER_STRIP];

bool break_flagA=false; //STRIP 0 & 2  
bool break_flagB=false; //STRIP 1
bool break_flagC=false; //STRIP 4
bool break_flagD=false; //STRIP 3 & 5  
bool stop_flag=false;

// For mirroring strips, all the "special" stuff happens just in setup.  We
// just addLeds multiple times, once for each strip
void setup() {
  Serial.begin(9600);
//  Timer1.initialize(100000); 
//  Timer1.attachInterrupt(check_restart);
  initialise_RGBButtons();
  initialise_LEDStrips();
  reset_all(BLUE);
    pinMode(13, INPUT);
  attachInterrupt(digitalPinToInterrupt(13), check_restart, HIGH);
}

void loop() {

if(stop_flag){
  delay(5000);
  software_Reset();
}

  else if(!stop_flag){

long path = random(0, 3);
  
switch (path) {
    case 0:
      //virus_attack(0,NUM_LEDS_STRIP0,1);
       virus_attack(1,NUM_LEDS_STRIP1,2);
        virus_attack(2,NUM_LEDS_STRIP2,1);
        //virus_attack(3,NUM_LEDS_STRIP3,4);
        virus_attack(4,NUM_LEDS_STRIP4,3);
        virus_attack(5,NUM_LEDS_STRIP5,4);
        //virus_attack(6,NUM_LEDS_STRIP6,0);
        virus_attack(7,NUM_LEDS_STRIP7,0);
      break;
    case 1:
      virus_attack(0,NUM_LEDS_STRIP0,1);
        virus_attack(4,NUM_LEDS_STRIP4,3);
        virus_attack(5,NUM_LEDS_STRIP5,4);
        virus_attack(7,NUM_LEDS_STRIP7,0);
      break; 
     case 2:
      virus_attack(1,NUM_LEDS_STRIP1,2);
        virus_attack(3,NUM_LEDS_STRIP3,4);
        virus_attack(7,NUM_LEDS_STRIP7,0);
      break;  
    default:
    set_allStrips(BLUE);
    } 
        
if(!stop_flag){
  reset_all(RED);
delay (5000);
reset_all(BLUE);
}
  }
  }
/*
 if  (break_flagA){
  Serial.println("in");
  long second_set = random(2, 4);
  
  switch (second_set) {
    case 2:
      virus_attack(2,NUM_LEDS_STRIP2,2);
      virus_attack(7,NUM_LEDS_STRIP7,0);
//      if (Button1_currentbuttonState==HIGH){
//        ToggleButtonLED(1);
//        Button1_currentbuttonState=LOW;
//        break_flag=false;
//      }
     break;
    case 3:
      virus_attack(3,NUM_LEDS_STRIP3,4);
//        if (Button2_currentbuttonState==HIGH){
//        ToggleButtonLED(2);
//        Button2_currentbuttonState=LOW;
//        break_flag=false;
//        }
    break;
    default:
    set_allStrips(BLUE);
    }
}*/

  

  /*

    for(int i = 0; i < NUM_LEDS_PER_STRIP; i++) {
      if (Button1_currentbuttonState==HIGH){
        ToggleLED(Button1_Red,Button1_Blue,Button1_RedState,Button1_BlueState);
        Button1_currentbuttonState=LOW;
        break;
      }
      leds[0][i] = CRGB::Red;
      leds[1][i] = CRGB::Red;
      FastLED.show();
      //leds[1][i] = CRGB::Black;
      delay(100);
    }
  //}

  */

void initialise_RGBButtons(){

  pinMode(Button1_Red, OUTPUT);
  pinMode(Button1_Blue, OUTPUT);
  pinMode(Button1_Feedback, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(Button1_Feedback), change_Button1State, RISING);

  pinMode(Button2_Red, OUTPUT);
  pinMode(Button2_Blue, OUTPUT);
  pinMode(Button2_Feedback, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(Button2_Feedback), change_Button2State, RISING);

  pinMode(Button3_Red, OUTPUT);
  pinMode(Button3_Blue, OUTPUT);
  pinMode(Button3_Feedback, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(Button3_Feedback), change_Button3State, RISING);

  pinMode(Button4_Red, OUTPUT);
  pinMode(Button4_Blue, OUTPUT);
  pinMode(Button4_Feedback, INPUT_PULLUP);
  attachInterrupt(digitalPinToInterrupt(Button4_Feedback), change_Button4State, RISING); 
  
}

void initialise_LEDStrips(){
  
  // tell FastLED there's 60 NEOPIXEL leds on pin 3
  FastLED.addLeds<NEOPIXEL, 3>(leds[0], NUM_LEDS_PER_STRIP);

  // tell FastLED there's 60 NEOPIXEL leds on pin 4
  FastLED.addLeds<NEOPIXEL, 4>(leds[1], NUM_LEDS_PER_STRIP);

  // tell FastLED there's 60 NEOPIXEL leds on pin 6
  FastLED.addLeds<NEOPIXEL, 6>(leds[2], NUM_LEDS_PER_STRIP);

  // tell FastLED there's 60 NEOPIXEL leds on pin 7
  FastLED.addLeds<NEOPIXEL, 7>(leds[3], NUM_LEDS_PER_STRIP);

  // tell FastLED there's 60 NEOPIXEL leds on pin 11
  FastLED.addLeds<NEOPIXEL, 11>(leds[4], NUM_LEDS_PER_STRIP);

    // tell FastLED there's 60 NEOPIXEL leds on pin 8
  FastLED.addLeds<NEOPIXEL, 8>(leds[5], NUM_LEDS_PER_STRIP);

  // tell FastLED there's 60 NEOPIXEL leds on pin 12
  FastLED.addLeds<NEOPIXEL, 12>(leds[6], NUM_LEDS_PER_STRIP);

  // tell FastLED there's 60 NEOPIXEL leds on pin 9
  FastLED.addLeds<NEOPIXEL, 9>(leds[7], NUM_LEDS_PER_STRIP);

}

void virus_attack(int strip_num,int NUM_LEDS,int button_num){
  stop_flag=false;
  if (strip_num==2 || strip_num==4 ||strip_num==5 || strip_num==6 || strip_num==7){
  for(int i = NUM_LEDS; i >= 0; i--){
     if (strip_num==2){
      if (break_flagA){
       digitalWrite(13, HIGH); 
       //reset_all(BLUE);
        break;}
      }
      else if(strip_num==4){
      if (break_flagC){
       digitalWrite(13, HIGH); 
       //reset_all(BLUE);
        break;}
      }
      else if(strip_num==5){
      if (break_flagD){
       digitalWrite(13, HIGH);
       //reset_all(BLUE);
        break;}
      }
    leds[strip_num][i] = CRGB::Red;
      FastLED.show();
      delay(50);
  } 
  }
  if (strip_num==0 || strip_num==1 ||strip_num==3){
  for(int j = 0; j < NUM_LEDS; j++){
     if (strip_num==0){
      if (break_flagA){
       digitalWrite(13, HIGH); 
       //reset_all(BLUE);       
        break;}
      }
      else if(strip_num==1){
      if (break_flagB){
       digitalWrite(13, HIGH);        
       //reset_all(BLUE);
        break;}
      }
      else if(strip_num==3){
      if (break_flagD){
       digitalWrite(13, HIGH); 
       //reset_all(BLUE);
        break;}
      }
    leds[strip_num][j] = CRGB::Red;
      FastLED.show();
      delay(50);
  }
  }
  SetButtonLED(button_num, RED);
}

void set_allStrips(uint32_t c){

  for(int i = 0; i < NUM_LEDS_PER_STRIP; i++) {
      leds[0][i] = c; //1
      leds[1][i] = c; //2
      leds[2][i] = c; //3
      leds[3][i] = c; //4
      leds[4][i] = c; //5
      leds[5][i] = c; //6
      leds[6][i] = c; //7
      leds[7][i] = c; //8
      FastLED.show();
      delay(1);
    }

}

void reset_all(uint32_t c){
  set_allStrips(c);
  SetButtonLED(1, c);
  SetButtonLED(2, c);
  SetButtonLED(3, c);
  SetButtonLED(4, c);
}
void change_Button1State() {

 Button1_currentbuttonState=HIGH;
 break_flagA=true;
  /*
int reading = digitalRead(buttonPin);
if (reading != lastButtonState) {
    // reset the debouncing timer
    lastDebounceTime = millis();
  }
if ((millis() - lastDebounceTime) > debounceDelay) {
  if (reading != buttonState) {
      buttonState = reading;
   if (buttonState == LOW) {
      ToggleLED(RedPin, BluePin, RedState, BlueState);
  }

  }
}
lastButtonState = reading;
*/
}
void change_Button2State() {

 Button2_currentbuttonState=HIGH;
  break_flagB=true;
}

void change_Button3State() {

 Button3_currentbuttonState=HIGH;
 break_flagC=true;
}

void change_Button4State() {

 Button4_currentbuttonState=HIGH;
 break_flagD=true;
}

void SetButtonLED(int button_num, uint32_t c){
  switch (button_num) {
  case 1:
    if (c==BLUE){
      Button1_RedState=LOW;
      Button1_BlueState=HIGH;
      analogWrite(Button1_Red, 0);
      analogWrite(Button1_Blue, 255);
    }

    else if (c==RED){
      Button1_RedState=HIGH;
      Button1_BlueState=LOW;
      analogWrite(Button1_Red, 255);
      analogWrite(Button1_Blue, 0);
    }
    break;
   case 2:
    if (c==BLUE){
      Button2_RedState=LOW;
      Button2_BlueState=HIGH;
      analogWrite(Button2_Red, 0);
      analogWrite(Button2_Blue, 255);
    }

    else if (c==RED){
      Button2_RedState=HIGH;
      Button2_BlueState=LOW;
      analogWrite(Button2_Red, 255);
      analogWrite(Button2_Blue, 0);
    }
    break;
   case 3:
    if (c==BLUE){
      Button3_RedState=LOW;
      Button3_BlueState=HIGH;
      analogWrite(Button3_Red, 0);
      analogWrite(Button3_Blue, 255);
    }

    else if (c==RED){
      Button3_RedState=HIGH;
      Button3_BlueState=LOW;
      analogWrite(Button3_Red, 255);
      analogWrite(Button3_Blue, 0);
    }
    break;
   case 4:
    if (c==BLUE){
      Button4_RedState=LOW;
      Button4_BlueState=HIGH;
      analogWrite(Button4_Red, 0);
      analogWrite(Button4_Blue, 255);
    }

    else if (c==RED){
      Button4_RedState=HIGH;
      Button4_BlueState=LOW;
      analogWrite(Button4_Red, 255);
      analogWrite(Button4_Blue, 0);
    }
    break;
    default:

    break;
  }
}
void ToggleButtonLED(int button_num) {

  switch (button_num) {
  case 1:
    if (Button1_RedState==HIGH){
      Button1_RedState=LOW;
      Button1_BlueState=HIGH;
      analogWrite(Button1_Red, 0);
      analogWrite(Button1_Blue, 255);
    }

    else if (Button1_BlueState==HIGH){
      Button1_RedState=HIGH;
      Button1_BlueState=LOW;
      analogWrite(Button1_Red, 255);
      analogWrite(Button1_Blue, 0);
    }
    break;
  case 2:
    if (Button2_RedState==HIGH){
      Button2_RedState=LOW;
      Button2_BlueState=HIGH;
      analogWrite(Button2_Red, 0);
      analogWrite(Button2_Blue, 255);
    }

    else if (Button2_BlueState==HIGH){
      Button2_RedState=HIGH;
      Button2_BlueState=LOW;
      analogWrite(Button2_Red, 255);
      analogWrite(Button2_Blue, 0);
    }
    break;
   case 3:
    if (Button3_RedState==HIGH){
      Button3_RedState=LOW;
      Button3_BlueState=HIGH;
      analogWrite(Button3_Red, 0);
      analogWrite(Button3_Blue, 255);
    }

    else if (Button3_BlueState==HIGH){
      Button3_RedState=HIGH;
      Button3_BlueState=LOW;
      analogWrite(Button3_Red, 255);
      analogWrite(Button3_Blue, 0);
    }
    break;
   case 4:
    if (Button4_RedState==HIGH){
      Button4_RedState=LOW;
      Button4_BlueState=HIGH;
      analogWrite(Button4_Red, 0);
      analogWrite(Button4_Blue, 255);
    }

    else if (Button4_BlueState==HIGH){
      Button4_RedState=HIGH;
      Button4_BlueState=LOW;
      analogWrite(Button4_Red, 255);
      analogWrite(Button4_Blue, 0);
    }
    break;
    
    default:

    break;
  }
}

void software_Reset() // Restarts program from beginning but does not reset the peripherals and registers
{
asm volatile ("  jmp 0");  
} 

void check_restart(){
  software_Reset();

//  if(stop_flag){
//  //delay(5000);
//  software_Reset();}
}

